﻿//using Intents;
//using System.Linq.Expressions;
using System.Diagnostics;
using System.Xml.Linq;

namespace MauiApp1
{
    using Stan = (byte r, byte g, byte b);

    public partial class MainPage : ContentPage
    {
        private bool aktualizujWidok = true;

        public MainPage()
        {            
            InitializeComponent();

            Stan stan = czytajStanZPlikuXml();            
            aktualizujWidok = false;
            sliderG.Value = stan.g;
            sliderB.Value = stan.b;
            aktualizujWidok = true;
            sliderR.Value = stan.r;                        
        }        

        private Stan odczytajStanZKontrolek()
        {
            byte r = (byte)sliderR.Value;
            byte g = (byte)sliderG.Value;
            byte b = (byte)sliderB.Value;                        
            return new Stan(r, g, b);
        }

        private bool pierwszyRaz = false;

        private void Slider_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (!aktualizujWidok) return;
            Stan stan = odczytajStanZKontrolek();
            zapiszStanDoPlikuXml(stan);
            Color kolor = Color.FromRgb(stan.r, stan.g, stan.b);
            rectangle.Fill = new SolidColorBrush(kolor);
        }

        private void Button_Clicked(object sender, EventArgs e)
        {
            aktualizujWidok = false;
            sliderR.Value = 0;
            sliderG.Value = 0;
            aktualizujWidok = true;
            sliderB.Value = 0;
        }

        private string ścieżkaPliku =
            Path.Combine(
                Environment.GetFolderPath(Environment.SpecialFolder.UserProfile),
                "ustawienia.xml");

        private void zapiszStanDoPlikuXml(Stan stan)
        {
            XDocument xml = new XDocument(
                new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("Data zapisu: " + DateTime.Now.ToString()),
                new XElement("ustawienia",
                    new XElement("r", stan.r),
                    new XElement("g", stan.g),
                    new XElement("b", stan.b)
                )
            );

            try
            {
                xml.Save(ścieżkaPliku);
            }
            catch(Exception exc)
            {
                Debug.WriteLine($"Nie udało się zapisać stanu aplikacji. Błąd: {exc.Message}");
            }
        }

        private void ContentPage_Disappearing(object sender, EventArgs e)
        {
            Stan stan = odczytajStanZKontrolek();
            zapiszStanDoPlikuXml(stan);
        }

        private Stan czytajStanZPlikuXml()
        {            
            try
            {
                XDocument xml = XDocument.Load(ścieżkaPliku);
                byte r = byte.Parse(xml.Root.Element("r").Value);
                byte g = byte.Parse(xml.Root.Element("g").Value);
                byte b = byte.Parse(xml.Root.Element("b").Value);
                return new Stan(r, g, b);
            }
            catch 
            {
                return new Stan(0, 0, 0);
            }
        }

        private void ContentPage_Appearing(object sender, EventArgs e)
        {
#if ANDROID
            //TODO: nie działa (naprawić)
            this.Window.Deactivated += ContentPage_Disappearing;
#endif
        }
    }
}
